/// <reference types="node" />
declare type FileSystemLocation = {
    path: string;
    projectRoot: string;
};
declare type CopyInstructions = {
    source: string;
    target: string;
    projectRoot: string;
};
declare type WriteFileInstructions = {
    path: string;
    content: string;
    projectRoot: string;
};
declare type ZipInstructions = {
    source: string;
    target: string;
    name: string;
    projectRoot: string;
};
export declare function getDirectories(input: FileSystemLocation): string[];
export declare function makeDir(input: FileSystemLocation): Promise<void>;
export declare function removeDir(input: FileSystemLocation): Promise<void>;
export declare function copyDir(input: CopyInstructions): void;
export declare function zipFolder(input: ZipInstructions): Promise<void>;
export declare function getFile(input: FileSystemLocation): Promise<Buffer>;
export declare function getJsFile(input: FileSystemLocation): Promise<any>;
export declare function writeFile(input: WriteFileInstructions): void;
export declare function removeFile(input: FileSystemLocation): void;
export declare function copyFile(input: CopyInstructions): void;
export declare function getTextContent(input: FileSystemLocation): Promise<string>;
export {};
