"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTextContent = exports.copyFile = exports.removeFile = exports.writeFile = exports.getJsFile = exports.getFile = exports.zipFolder = exports.copyDir = exports.removeDir = exports.makeDir = exports.getDirectories = void 0;
var fs_extra_1 = __importDefault(require("fs-extra"));
var fs_1 = __importDefault(require("fs"));
var archiver_1 = __importDefault(require("archiver"));
function getDirectories(input) {
    return fs_extra_1.default
        .readdirSync(input.projectRoot + input.path, { withFileTypes: true })
        .filter(function (dirent) { return dirent.isDirectory(); })
        .map(function (dirent) { return dirent.name; });
}
exports.getDirectories = getDirectories;
function makeDir(input) {
    return __awaiter(this, void 0, void 0, function () {
        var e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4, fs_extra_1.default.mkdir(input.projectRoot + input.path)];
                case 1:
                    _a.sent();
                    return [3, 3];
                case 2:
                    e_1 = _a.sent();
                    if (e_1 instanceof Error) {
                        if (e_1.message.startsWith('EEXIST: file already exists')) {
                            return [2];
                        }
                        throw new Error(e_1.message);
                    }
                    else {
                        throw new Error('Unknown Error');
                    }
                    return [3, 3];
                case 3: return [2];
            }
        });
    });
}
exports.makeDir = makeDir;
function removeDir(input) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            fs_extra_1.default.removeSync(input.projectRoot + input.path);
            return [2];
        });
    });
}
exports.removeDir = removeDir;
function copyDir(input) {
    fs_extra_1.default.copySync(input.projectRoot + input.source, input.projectRoot + input.target);
}
exports.copyDir = copyDir;
function zipFolder(input) {
    return __awaiter(this, void 0, void 0, function () {
        var COMPRESSION_LEVEL, source, target, name, archive, stream;
        return __generator(this, function (_a) {
            COMPRESSION_LEVEL = 9;
            source = input.projectRoot + input.source;
            target = input.projectRoot + input.target;
            name = input.name;
            if (!fs_1.default.existsSync(target)) {
                fs_1.default.mkdirSync(target);
            }
            if (target[target.length - 1] !== '/') {
                target = target + '/';
            }
            archive = (0, archiver_1.default)('zip', { zlib: { level: COMPRESSION_LEVEL } });
            stream = fs_1.default.createWriteStream(target + name + '.zip');
            return [2, new Promise(function (resolve, reject) {
                    archive
                        .directory(source, false)
                        .on('error', function (err) { return reject(err); })
                        .pipe(stream);
                    stream.on('close', function () { return resolve(); });
                    archive.finalize();
                })];
        });
    });
}
exports.zipFolder = zipFolder;
function getFile(input) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, fs_extra_1.default.readFile(input.projectRoot + input.path)];
                case 1: return [2, _a.sent()];
            }
        });
    });
}
exports.getFile = getFile;
function getJsFile(input) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2, require(input.projectRoot + input.path)];
        });
    });
}
exports.getJsFile = getJsFile;
function writeFile(input) {
    fs_extra_1.default.writeFileSync(input.projectRoot + input.path, input.content);
}
exports.writeFile = writeFile;
function removeFile(input) {
    fs_extra_1.default.removeSync(input.projectRoot + input.path);
}
exports.removeFile = removeFile;
function copyFile(input) {
    fs_extra_1.default.copyFileSync(input.projectRoot + input.source, input.projectRoot + input.target);
}
exports.copyFile = copyFile;
function getTextContent(input) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2, fs_1.default.readFileSync(input.projectRoot + input.path, 'utf8')];
        });
    });
}
exports.getTextContent = getTextContent;
